Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Administration/ServiceClient/AdministrationServiceClient.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Administration/ServiceClient/AdministrationServiceClient.cs	(revision 5533)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Administration/ServiceClient/AdministrationServiceClient.cs	(revision 5534)
@@ -10,5 +10,4 @@
 
 namespace HeuristicLab.Clients.OKB.Administration {
-  using System.Runtime.Serialization;
 
 
@@ -118,5 +117,7 @@
     private long AlgorithmClassIdField;
 
-    private HeuristicLab.Clients.OKB.Administration.DataType DataTypeField;
+    private string DataTypeNameField;
+
+    private string DataTypeTypeNameField;
 
     private long PlatformIdField;
@@ -136,12 +137,25 @@
 
     [System.Runtime.Serialization.DataMemberAttribute()]
-    public HeuristicLab.Clients.OKB.Administration.DataType DataType {
-      get {
-        return this.DataTypeField;
-      }
-      set {
-        if ((object.ReferenceEquals(this.DataTypeField, value) != true)) {
-          this.DataTypeField = value;
-          this.RaisePropertyChanged("DataType");
+    public string DataTypeName {
+      get {
+        return this.DataTypeNameField;
+      }
+      set {
+        if ((object.ReferenceEquals(this.DataTypeNameField, value) != true)) {
+          this.DataTypeNameField = value;
+          this.RaisePropertyChanged("DataTypeName");
+        }
+      }
+    }
+
+    [System.Runtime.Serialization.DataMemberAttribute()]
+    public string DataTypeTypeName {
+      get {
+        return this.DataTypeTypeNameField;
+      }
+      set {
+        if ((object.ReferenceEquals(this.DataTypeTypeNameField, value) != true)) {
+          this.DataTypeTypeNameField = value;
+          this.RaisePropertyChanged("DataTypeTypeName");
         }
       }
@@ -175,5 +189,7 @@
   public partial class Problem : HeuristicLab.Clients.OKB.Administration.NamedOKBItem {
 
-    private HeuristicLab.Clients.OKB.Administration.DataType DataTypeField;
+    private string DataTypeNameField;
+
+    private string DataTypeTypeNameField;
 
     private long PlatformIdField;
@@ -182,12 +198,25 @@
 
     [System.Runtime.Serialization.DataMemberAttribute()]
-    public HeuristicLab.Clients.OKB.Administration.DataType DataType {
-      get {
-        return this.DataTypeField;
-      }
-      set {
-        if ((object.ReferenceEquals(this.DataTypeField, value) != true)) {
-          this.DataTypeField = value;
-          this.RaisePropertyChanged("DataType");
+    public string DataTypeName {
+      get {
+        return this.DataTypeNameField;
+      }
+      set {
+        if ((object.ReferenceEquals(this.DataTypeNameField, value) != true)) {
+          this.DataTypeNameField = value;
+          this.RaisePropertyChanged("DataTypeName");
+        }
+      }
+    }
+
+    [System.Runtime.Serialization.DataMemberAttribute()]
+    public string DataTypeTypeName {
+      get {
+        return this.DataTypeTypeNameField;
+      }
+      set {
+        if ((object.ReferenceEquals(this.DataTypeTypeNameField, value) != true)) {
+          this.DataTypeTypeNameField = value;
+          this.RaisePropertyChanged("DataTypeTypeName");
         }
       }
@@ -221,61 +250,4 @@
   }
 
-  [System.Diagnostics.DebuggerStepThroughAttribute()]
-  [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Runtime.Serialization", "4.0.0.0")]
-  [System.Runtime.Serialization.DataContractAttribute(Name = "DataType", Namespace = "http://schemas.datacontract.org/2004/07/HeuristicLab.Services.OKB.Administration." +
-      "DataTransfer")]
-  public partial class DataType : object, System.Runtime.Serialization.IExtensibleDataObject, System.ComponentModel.INotifyPropertyChanged {
-
-    private System.Runtime.Serialization.ExtensionDataObject extensionDataField;
-
-    private string NameField;
-
-    private string TypeNameField;
-
-    public System.Runtime.Serialization.ExtensionDataObject ExtensionData {
-      get {
-        return this.extensionDataField;
-      }
-      set {
-        this.extensionDataField = value;
-      }
-    }
-
-    [System.Runtime.Serialization.DataMemberAttribute()]
-    public string Name {
-      get {
-        return this.NameField;
-      }
-      set {
-        if ((object.ReferenceEquals(this.NameField, value) != true)) {
-          this.NameField = value;
-          this.RaisePropertyChanged("Name");
-        }
-      }
-    }
-
-    [System.Runtime.Serialization.DataMemberAttribute()]
-    public string TypeName {
-      get {
-        return this.TypeNameField;
-      }
-      set {
-        if ((object.ReferenceEquals(this.TypeNameField, value) != true)) {
-          this.TypeNameField = value;
-          this.RaisePropertyChanged("TypeName");
-        }
-      }
-    }
-
-    public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;
-
-    protected void RaisePropertyChanged(string propertyName) {
-      System.ComponentModel.PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
-      if ((propertyChanged != null)) {
-        propertyChanged(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
-      }
-    }
-  }
-
   [System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "4.0.0.0")]
   [System.ServiceModel.ServiceContractAttribute(ConfigurationName = "HeuristicLab.Clients.OKB.Administration.IAdministrationService")]
Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Administration/ServiceClient/Algorithm.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Administration/ServiceClient/Algorithm.cs	(revision 5533)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Administration/ServiceClient/Algorithm.cs	(revision 5534)
@@ -30,4 +30,6 @@
       PlatformId = original.PlatformId;
       AlgorithmClassId = original.AlgorithmClassId;
+      DataTypeName = original.DataTypeName;
+      DataTypeTypeName = original.DataTypeTypeName;
     }
     public Algorithm() {
@@ -35,4 +37,6 @@
       PlatformId = 1;
       AlgorithmClassId = 1;
+      DataTypeName = "Unknown";
+      DataTypeTypeName = "Unknown";
     }
 
Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Administration/ServiceClient/NamedOKBItem.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Administration/ServiceClient/NamedOKBItem.cs	(revision 5533)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Administration/ServiceClient/NamedOKBItem.cs	(revision 5534)
@@ -33,5 +33,5 @@
     }
     public NamedOKBItem() {
-      Name = "New Item";
+      Name = "New OKB Item";
       Description = string.Empty;
     }
Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Administration/ServiceClient/Problem.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Administration/ServiceClient/Problem.cs	(revision 5533)
+++ branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/Administration/ServiceClient/Problem.cs	(revision 5534)
@@ -30,4 +30,6 @@
       PlatformId = original.PlatformId;
       ProblemClassId = original.ProblemClassId;
+      DataTypeName = original.DataTypeName;
+      DataTypeTypeName = original.DataTypeTypeName;
     }
     public Problem() {
@@ -35,4 +37,6 @@
       PlatformId = 1;
       ProblemClassId = 1;
+      DataTypeName = "Unknown";
+      DataTypeTypeName = "Unknown";
     }
 